//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    SZOPeriod       = 14;
extern int    SZOLongPeriod   = 30;
extern int    SZOPrice        = PRICE_CLOSE;
extern double SZOPercent      = 95;
extern int    AveragePeriod   = 14;
extern int    AverageType     = MODE_EMA;
extern bool   Interpolate     = true;

//
//
//
//
//

double upz[];
double upzUa[];
double upzUb[];
double dnz[];
double dnzDa[];
double dnzDb[];
double szo[];
double average[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,upzUa); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnzDa); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,upz);
   SetIndexBuffer(3,dnz);
   SetIndexBuffer(4,szo);
   SetIndexBuffer(5,average);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
      IndicatorShortName(timeFrameToString(timeFrame)+" Sentiment zone oscillator ("+SZOPeriod+","+SZOLongPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double prices[];
double breakout[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { upzUa[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //


   if (ArraySize(breakout)!=Bars) ArrayResize(breakout,Bars);
   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(prices)!=Bars) ArrayResize(prices,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         prices[r] = iMA(NULL,0,1,0,MODE_SMA,SZOPrice,i);
            double useValue = 0;
               if (prices[r]>prices[r-1]) useValue =  1;
               if (prices[r]<prices[r-1]) useValue = -1;
            double result = 100.0*iTema(useValue,SZOPeriod,i);
      
            //
            //
            //
            //
            //
         
            szo[i] =  result/SZOPeriod;
               double hi = szo[ArrayMaximum(szo,SZOLongPeriod,i)];
               double lo = szo[ArrayMinimum(szo,SZOLongPeriod,i)];
               double rn = hi-lo;
            upz[i]   = lo+rn*SZOPercent/100.0;
            dnz[i]   = hi-rn*SZOPercent/100.0;
            upzUa[i] = EMPTY_VALUE;
            dnzDa[i] = EMPTY_VALUE;
            breakout[r] = breakout[r-1];
               if (szo[i]>upz[i])                  breakout[r] =  1;
               if (szo[i]<dnz[i])                  breakout[r] = -1;
               if (szo[i]>dnz[i] && szo[i]<upz[i]) breakout[r] =  0;
               if (breakout[r] ==  1) upzUa[i] = 1;
               if (breakout[r] == -1) dnzDa[i] = 1;
               
      }       
      for(i=limit; i>=0; i--) average[i] = iMAOnArray(szo,0,AveragePeriod,0,AverageType,i);
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         upzUa[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SZOPeriod,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,0,y);
         dnzDa[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SZOPeriod,SZOLongPeriod,SZOPrice,SZOPercent,AveragePeriod,AverageType,1,y);
   }
   return(0);
         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workTema[][3];
#define _ema1 0
#define _ema2 1
#define _ema3 2

double iTema(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workTema,0)!= Bars) ArrayResize(workTema,Bars); instanceNo*=3; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workTema[r][_ema1+instanceNo] = workTema[r-1][_ema1+instanceNo]+alpha*(price                        -workTema[r-1][_ema1+instanceNo]);
          workTema[r][_ema2+instanceNo] = workTema[r-1][_ema2+instanceNo]+alpha*(workTema[r][_ema1+instanceNo]-workTema[r-1][_ema2+instanceNo]);
          workTema[r][_ema3+instanceNo] = workTema[r-1][_ema3+instanceNo]+alpha*(workTema[r][_ema2+instanceNo]-workTema[r-1][_ema3+instanceNo]);
   return(workTema[r][_ema3+instanceNo]+3.0*(workTema[r][_ema1+instanceNo]-workTema[r][_ema2+instanceNo]));
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}